structure MISTest =
struct

structure Table = Default.IntTable
structure Set = Table.Set
structure Seq = Default.Seq
structure MIS = TableMIS(Table)

fun toGraph eF =
let
    val eB = Seq.map (fn (u,v) => (v,u)) eF
in 
    Table.map Set.fromSeq (Table.collect(Seq.append(eF,eB)))
end

fun test () =
    let
	val E = Seq.fromList [(0,1),(0,2),(1,3),(2,3),(3,4),(4,5),(5,6),(0,6)]
	val G = toGraph E
	val M = MIS.MIS(G)
    in
	Set.toSeq M
    end

end
