#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

#define MAXPT 32

struct spair {
  int index, a, b;

  bool operator() (spair i, spair j)
  { return (i.a < j.a) || (i.a == j.a && i.b < j.b); }

} opair;

void suffixArray(char *s)
{
  int n=strlen(s);
  int R[MAXPT][n];
  for (int i=0;i<n;i++) R[0][i]=s[i];

  int logsz,sz;
  for (sz=2,logsz=1;sz<n;sz=sz*2,logsz++) {
    spair ss[n];

    for (int i=0;i<n;i++) {
      ss[i].index=i;
      ss[i].a=R[logsz-1][i];
      ss[i].b=(i+(sz/2)>=n)?-1:R[logsz-1][i+(sz/2)];
      //      cout << "ss[i]: i=" << i << ", a="<<ss[i].a<<", b="<<ss[i].b<<endl;
    }
    sort(ss, ss + n, opair);
    for (int cnt=-1,i=0;i<n;i++) {
      if (i==0 || !(ss[i].a==ss[i-1].a && ss[i].b==ss[i-1].b))
        cnt++;
      R[logsz][ss[i].index]=cnt;
    }
    //    cout << "logsz: " << logsz << ", sz: " << sz << endl;
    //    for (int i=0;i<n;i++)
    //      cout << R[logsz][i] << " ";
    //    cout<<endl;
  }
  spair ss[n];
  for (int i=0;i<n;i++) {
    ss[i].index=i;
    ss[i].a=R[logsz-1][i];
    ss[i].b=(i+(sz/2)>=n)?-1:R[logsz-1][i+(sz/2)];
  }
  sort(ss, ss + n, opair);

  for (int i=0;i<n;i++)
    cout << ss[i].index << " ";
  cout<<endl;
}

int main(int argc, char *argv[])
{
  if (argc>1)
    suffixArray(argv[1]);

  return 0;
}
