(TeX-add-style-hook "lecture11"
 (lambda ()
    (LaTeX-add-environments
     "codels")
    (LaTeX-add-labels
     "fig:lec11::friends"
     "fig:lec11::levels"
     "fig:lec11::climbing-dag"
     "fig:lec11::climbing-dag-start"
     "fig:lec11::pebbles"
     "fig:lec11::dfs-tree"
     "the::DAG"
     "fig:topsort")
    (TeX-add-symbols
     '("newlls" ["argument"] 1)
     '("newll" ["argument"] 0)
     '("dedge" 2)
     '("clabel" 1)
     "updatecolor"
     "dfs"
     "csep"
     "foo"
     "bfs"
     "ctouchf"
     "centerf"
     "cexitf")
    (TeX-run-style-hooks
     "microtype"
     "tikz"
     "multirow"
     "colortbl"
     "booktabs"
     "tabularx"
     "verbatim"
     ""
     "latex2e"
     "art11"
     "article"
     "11pt")))

