(***************************************************************
 * SpanningTree TEST 
 ***************************************************************)

structure SpanningTreeTest =
struct

structure Seq = Default.Seq
structure SpanningTree = SeqSpanningTree(Seq)

fun checkEq(a,b,s) = 
    case (Seq.collate Int.compare (a,b)) of
      EQUAL => ()
    | _ => raise TH.FAILED s

fun test() =
  let
    open Seq
    val E = fromList [(0,1),(1,3),(3,4),(0,3),(5,6),(6,7),(5,7)]
    val E' = append(E, map (fn (u,v) => (v,u)) E)
    (*val _  = checkEq(SpanningTree.labelComponents(E',8),
		     fromList [4,4,2,4,4,7,7,7],
		     "labelComponents") *)
    val _ = if length(SpanningTree.spanningTree(E',8)) <> 5 
	    then raise TH.FAILED "spanningTree"
	    else ()
  in
    ()
  end

end
