(TeX-add-style-hook "lect"
 (lambda ()
    (LaTeX-add-environments
     "theorem"
     "algorithm"
     "pseudocode"
     "claim"
     "conjecture"
     "corollary"
     "costspec"
     "example"
     "fact"
     "lemma"
     "notation"
     "observation"
     "proposition"
     "question"
     "summary"
     "definition"
     "problem"
     "remark"
     "mlcodea"
     "mlcodeb"
     "exercise"
     "itemize")
    (TeX-add-symbols
     '("expct" ["argument"] 1)
     '("prob" ["argument"] 1)
     '("ur" 1)
     '("uremark" 1)
     '("inclass" 1)
     '("myremark" 3)
     '("ttt" 1)
     '("itemreftwo" 2)
     '("itemref" 1)
     '("ineqpageref" 1)
     '("ineqreftwo" 2)
     '("ineqref" 1)
     '("eqpageref" 1)
     '("eqreftwo" 2)
     '("defpageref" 1)
     '("defreftwo" 2)
     '("defref" 1)
     '("corref" 1)
     '("lempageref" 1)
     '("lemrefthree" 3)
     '("lemreftwo" 2)
     '("lemref" 1)
     '("thmpageref" 1)
     '("thmreftwo" 2)
     '("thmref" 1)
     '("linerefrange" 2)
     '("linerefthree" 3)
     '("linereftwo" 2)
     '("lineref" 1)
     '("caseref" 1)
     '("stref" 1)
     '("tabreftwo" 2)
     '("tabref" 1)
     '("figpageref" 1)
     '("figreffour" 4)
     '("figrefthree" 3)
     '("figreftwo" 2)
     '("figref" 1)
     '("appref" 1)
     '("secrefthree" 3)
     '("secreftwo" 2)
     '("subsecref" 1)
     '("secref" 1)
     '("chrefthree" 3)
     '("chreftwo" 2)
     '("chref" 1)
     '("partref" 1)
     '("pref" 1)
     '("prefs" 2)
     '("spref" 1)
     '("company" 1)
     '("optionalb" 1)
     '("optional" 1)
     '("LectureTitle" 1)
     '("LectureDate" 1)
     '("LectureVersion" 1)
     '("LectureNumber" 1)
     '("Lecturer" 1)
     '("levelGate" 2)
     '("bookupdate" 1)
     '("bcswitch" 2)
     '("probName" 1)
     '("fn" 1)
     '("kw" 1)
     '("norm" 1)
     '("set" 1)
     '("pparen" 1)
     '("onef" 1)
     '("cull" 1)
     '("ignore" 1)
     "bmmax"
     "hmmax"
     "Prx"
     "E"
     "Ex"
     "Var"
     "Varx"
     "Cov"
     "Covx"
     "otilde"
     "eps"
     "vareps"
     "la"
     "ra"
     "wh"
     "wt"
     "R"
     "N"
     "Z"
     "F"
     "Q"
     "C"
     "poly"
     "polylog"
     "sgn"
     "avg"
     "val"
     "PCLASS"
     "NPCLASS"
     "pEREW"
     "pPRAM"
     "pCRCW"
     "horz"
     "embreak"
     "umut"
     "guy"
     "calA"
     "calB"
     "calC"
     "calD"
     "calE"
     "calF"
     "calG"
     "calH"
     "calI"
     "calJ"
     "calK"
     "calL"
     "calM"
     "calN"
     "calO"
     "calP"
     "calQ"
     "calR"
     "calS"
     "calT"
     "calU"
     "calV"
     "calW"
     "calX"
     "calY"
     "calZ"
     "fbits"
     "fbitsn"
     "levelAdmin"
     "levelE"
     "levelM"
     "levelD"
     "levelLecture"
     "levelLectureNotes"
     "levelBook"
     "levelLectureSummaryE"
     "levelLectureSummaryM"
     "levelLectureSummaryD"
     "levelLectureSummary"
     "compilationLevel"
     "setupLectureDelivery"
     "headerwidth"
     "MakeScribeTop"
     "indentedwidth"
     "algorithmcolor"
     "costcolor"
     "definitioncolor"
     "examplecolor"
     "exercisecolor"
     "pseudocodecolor"
     "questioncolor"
     "remarkcolor"
     "summarycolor"
     "lemmacolor"
     "theoremcolor"
     "eod"
     "ScribeStr"
     "LecStr"
     "LecNum"
     "LecVer"
     "LecDate"
     "LecTitle"
     "thefootnote")
    (TeX-run-style-hooks
     "xcolor"
     "dvipsnames"
     "usenames"
     "relsize"
     "fancyhdr"
     "hyperref"
     "urlcolor=Sepia"
     "linkcolor=MidnightBlue"
     "colorlinks=true"
     "enumitem"
     "mathdesign"
     "cal=cmcal"
     "bitstream-charter"
     "fontenc"
     "T1"
     "helvet"
     "scaled=.9"
     "xspace"
     "bm"
     "epsfig"
     "latexsym"
     "amsthm"
     "amsmath"
     "amsfonts"
     "amssymb"
     ""
     "geometry"
     "margin=1.1in")))

